
_write2bytes:

;ATmega644P_AD7323.c,5 :: 		uint16_t write2bytes(uint16_t command) {
;ATmega644P_AD7323.c,9 :: 		higherByte = (uint8_t)((command & 0xFF00) >> 8);
	MOVW       R16, R2
	ANDI       R16, 0
	ANDI       R17, 255
	MOV        R18, R17
	LDI        R19, 0
;ATmega644P_AD7323.c,10 :: 		lowerByte = (uint8_t)(command & 0x00FF);
	MOV        R16, R2
	ANDI       R16, 255
; lowerByte start address is: 16 (R16)
;ATmega644P_AD7323.c,12 :: 		Chip_Select = 0;
	IN         R27, PORTB4_bit+0
	CBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,14 :: 		SPDR = higherByte;  // sending high byte first
	OUT        SPDR+0, R18
; lowerByte end address is: 16 (R16)
	MOV        R18, R16
;ATmega644P_AD7323.c,15 :: 		while(!(SPSR & (1<<SPIF)));
L_write2bytes0:
; lowerByte start address is: 18 (R18)
	IN         R16, SPSR+0
	SBRC       R16, 7
	JMP        L_write2bytes1
	JMP        L_write2bytes0
L_write2bytes1:
;ATmega644P_AD7323.c,16 :: 		result = SPDR & 0xFF;
	IN         R16, SPDR+0
	ANDI       R16, 255
; result start address is: 19 (R19)
	MOV        R19, R16
	LDI        R20, 0
;ATmega644P_AD7323.c,17 :: 		result <<= 8;
	MOV        R17, R19
	CLR        R16
; result end address is: 19 (R19)
; result start address is: 16 (R16)
;ATmega644P_AD7323.c,18 :: 		SPDR = lowerByte;  // sending low byte
	OUT        SPDR+0, R18
; lowerByte end address is: 18 (R18)
; result end address is: 16 (R16)
	MOVW       R18, R16
;ATmega644P_AD7323.c,19 :: 		while(!(SPSR & (1<<SPIF)));
L_write2bytes2:
; result start address is: 18 (R18)
	IN         R16, SPSR+0
	SBRC       R16, 7
	JMP        L_write2bytes3
	JMP        L_write2bytes2
L_write2bytes3:
;ATmega644P_AD7323.c,20 :: 		result |= SPDR;
	IN         R16, SPDR+0
	LDI        R17, 0
	OR         R16, R18
	OR         R17, R19
; result end address is: 18 (R18)
;ATmega644P_AD7323.c,22 :: 		Chip_Select = 1;
	IN         R27, PORTB4_bit+0
	SBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,24 :: 		return result;
;ATmega644P_AD7323.c,25 :: 		}//write2bytes
L_end_write2bytes:
	RET
; end of _write2bytes

_setRangeRegister:

;ATmega644P_AD7323.c,27 :: 		void setRangeRegister(uint8_t ch, uint8_t range) {
;ATmega644P_AD7323.c,30 :: 		if ((ch < 0) || (ch > 3)) return;
	PUSH       R2
	PUSH       R3
	LDI        R27, 0
	CP         R2, R27
	BRSH       L__setRangeRegister32
	JMP        L__setRangeRegister26
L__setRangeRegister32:
	LDI        R16, 3
	CP         R16, R2
	BRSH       L__setRangeRegister33
	JMP        L__setRangeRegister25
L__setRangeRegister33:
	JMP        L_setRangeRegister6
L__setRangeRegister26:
L__setRangeRegister25:
	JMP        L_end_setRangeRegister
L_setRangeRegister6:
;ATmega644P_AD7323.c,32 :: 		switch (ch) {
	JMP        L_setRangeRegister7
;ATmega644P_AD7323.c,33 :: 		case 0:
L_setRangeRegister9:
;ATmega644P_AD7323.c,34 :: 		range_ &= CH0_MASK;
	LDS        R16, setRangeRegister_range__L0+0
	LDS        R17, setRangeRegister_range__L0+1
	MOVW       R18, R16
	ANDI       R18, 255
	ANDI       R19, 231
	STS        setRangeRegister_range__L0+0, R18
	STS        setRangeRegister_range__L0+1, R19
;ATmega644P_AD7323.c,35 :: 		range_ |= range << 11;
	LDI        R27, 11
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister34:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister34
L__setRangeRegister35:
	OR         R16, R18
	OR         R17, R19
	STS        setRangeRegister_range__L0+0, R16
	STS        setRangeRegister_range__L0+1, R17
;ATmega644P_AD7323.c,36 :: 		break;
	JMP        L_setRangeRegister8
;ATmega644P_AD7323.c,37 :: 		case 1:
L_setRangeRegister10:
;ATmega644P_AD7323.c,38 :: 		range_ &= CH1_MASK;
	LDS        R16, setRangeRegister_range__L0+0
	LDS        R17, setRangeRegister_range__L0+1
	MOVW       R18, R16
	ANDI       R18, 255
	ANDI       R19, 249
	STS        setRangeRegister_range__L0+0, R18
	STS        setRangeRegister_range__L0+1, R19
;ATmega644P_AD7323.c,39 :: 		range_ |= range << 9;
	LDI        R27, 9
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister36:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister36
L__setRangeRegister37:
	OR         R16, R18
	OR         R17, R19
	STS        setRangeRegister_range__L0+0, R16
	STS        setRangeRegister_range__L0+1, R17
;ATmega644P_AD7323.c,40 :: 		break;
	JMP        L_setRangeRegister8
;ATmega644P_AD7323.c,41 :: 		case 2:
L_setRangeRegister11:
;ATmega644P_AD7323.c,42 :: 		range_ &= CH2_MASK;
	LDS        R16, setRangeRegister_range__L0+0
	LDS        R17, setRangeRegister_range__L0+1
	MOVW       R18, R16
	ANDI       R18, 127
	ANDI       R19, 254
	STS        setRangeRegister_range__L0+0, R18
	STS        setRangeRegister_range__L0+1, R19
;ATmega644P_AD7323.c,43 :: 		range_ |= range << 7;
	LDI        R27, 7
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister38:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister38
L__setRangeRegister39:
	OR         R16, R18
	OR         R17, R19
	STS        setRangeRegister_range__L0+0, R16
	STS        setRangeRegister_range__L0+1, R17
;ATmega644P_AD7323.c,44 :: 		break;
	JMP        L_setRangeRegister8
;ATmega644P_AD7323.c,45 :: 		case 3:
L_setRangeRegister12:
;ATmega644P_AD7323.c,46 :: 		range_ &= CH3_MASK;
	LDS        R16, setRangeRegister_range__L0+0
	LDS        R17, setRangeRegister_range__L0+1
	MOVW       R18, R16
	ANDI       R18, 159
	ANDI       R19, 255
	STS        setRangeRegister_range__L0+0, R18
	STS        setRangeRegister_range__L0+1, R19
;ATmega644P_AD7323.c,47 :: 		range_ |= range << 5;
	LDI        R27, 5
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister40:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister40
L__setRangeRegister41:
	OR         R16, R18
	OR         R17, R19
	STS        setRangeRegister_range__L0+0, R16
	STS        setRangeRegister_range__L0+1, R17
;ATmega644P_AD7323.c,48 :: 		break;
	JMP        L_setRangeRegister8
;ATmega644P_AD7323.c,49 :: 		default: break;
L_setRangeRegister13:
	JMP        L_setRangeRegister8
;ATmega644P_AD7323.c,50 :: 		}//switch
L_setRangeRegister7:
	LDI        R27, 0
	CP         R2, R27
	BRNE       L__setRangeRegister42
	JMP        L_setRangeRegister9
L__setRangeRegister42:
	LDI        R27, 1
	CP         R2, R27
	BRNE       L__setRangeRegister43
	JMP        L_setRangeRegister10
L__setRangeRegister43:
	LDI        R27, 2
	CP         R2, R27
	BRNE       L__setRangeRegister44
	JMP        L_setRangeRegister11
L__setRangeRegister44:
	LDI        R27, 3
	CP         R2, R27
	BRNE       L__setRangeRegister45
	JMP        L_setRangeRegister12
L__setRangeRegister45:
	JMP        L_setRangeRegister13
L_setRangeRegister8:
;ATmega644P_AD7323.c,52 :: 		Chip_Select = 0;
	IN         R27, PORTB4_bit+0
	CBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,53 :: 		write2bytes(range_);
	LDS        R2, setRangeRegister_range__L0+0
	LDS        R3, setRangeRegister_range__L0+1
	CALL       _write2bytes+0
;ATmega644P_AD7323.c,54 :: 		Chip_Select = 1;
	IN         R27, PORTB4_bit+0
	SBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,57 :: 		}//setRangeRegister
;ATmega644P_AD7323.c,56 :: 		return;
;ATmega644P_AD7323.c,57 :: 		}//setRangeRegister
L_end_setRangeRegister:
	POP        R3
	POP        R2
	RET
; end of _setRangeRegister

_SPI_init:

;ATmega644P_AD7323.c,60 :: 		void SPI_init(void) {
;ATmega644P_AD7323.c,62 :: 		DDB6_bit = 0;              // Set PB6 pin as input (MISO)
	PUSH       R2
	IN         R27, DDB6_bit+0
	CBR        R27, BitMask(DDB6_bit+0)
	OUT        DDB6_bit+0, R27
;ATmega644P_AD7323.c,63 :: 		DDB5_bit = 1;              // Set PB5 pin as output (MOSI)
	IN         R27, DDB5_bit+0
	SBR        R27, BitMask(DDB5_bit+0)
	OUT        DDB5_bit+0, R27
;ATmega644P_AD7323.c,64 :: 		Chip_Select = 1;           // Deselect ADC
	IN         R27, PORTB4_bit+0
	SBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,65 :: 		Chip_Select_Direction = 1; // Set CS# pin as Output
	IN         R27, DDB4_bit+0
	SBR        R27, BitMask(DDB4_bit+0)
	OUT        DDB4_bit+0, R27
;ATmega644P_AD7323.c,66 :: 		SPI1_Init();
	CALL       _SPI1_Init+0
;ATmega644P_AD7323.c,68 :: 		Lcd_Init();                // Initialize LCD
	CALL       _Lcd_Init+0
;ATmega644P_AD7323.c,69 :: 		Lcd_Cmd(_LCD_CLEAR);       // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;ATmega644P_AD7323.c,70 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);  // Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;ATmega644P_AD7323.c,73 :: 		}//SPI_init
;ATmega644P_AD7323.c,72 :: 		return;
;ATmega644P_AD7323.c,73 :: 		}//SPI_init
L_end_SPI_init:
	POP        R2
	RET
; end of _SPI_init

_setControlRegister:

;ATmega644P_AD7323.c,75 :: 		void setControlRegister(uint8_t ch, uint16_t setup) {
;ATmega644P_AD7323.c,77 :: 		if ((ch < 0) || (ch > 7)) return;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	LDI        R27, 0
	CP         R2, R27
	BRSH       L__setControlRegister48
	JMP        L__setControlRegister29
L__setControlRegister48:
	LDI        R16, 7
	CP         R16, R2
	BRSH       L__setControlRegister49
	JMP        L__setControlRegister28
L__setControlRegister49:
	JMP        L_setControlRegister16
L__setControlRegister29:
L__setControlRegister28:
	JMP        L_end_setControlRegister
L_setControlRegister16:
;ATmega644P_AD7323.c,79 :: 		setup |= ((ch & 0x07) << 10);
	MOV        R16, R2
	ANDI       R16, 7
	LDI        R27, 10
	LDI        R17, 0
L__setControlRegister50:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setControlRegister50
L__setControlRegister51:
	OR         R16, R3
	OR         R17, R4
	MOV        R3, R16
	MOV        R4, R17
;ATmega644P_AD7323.c,80 :: 		Chip_Select = 0;
	IN         R27, PORTB4_bit+0
	CBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,81 :: 		write2bytes(setup);
	MOVW       R2, R16
	CALL       _write2bytes+0
;ATmega644P_AD7323.c,82 :: 		Chip_Select = 1;
	IN         R27, PORTB4_bit+0
	SBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7323.c,85 :: 		}//setControlRegister
;ATmega644P_AD7323.c,84 :: 		return;
;ATmega644P_AD7323.c,85 :: 		}//setControlRegister
L_end_setControlRegister:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _setControlRegister

_ADC7328_init:

;ATmega644P_AD7323.c,87 :: 		void ADC7328_init(void) {
;ATmega644P_AD7323.c,88 :: 		uint8_t i = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
;ATmega644P_AD7323.c,90 :: 		for (i = 0; i < 4; i++) setRangeRegister(i, BIP10); // Fill in both range registers
; i start address is: 17 (R17)
	LDI        R17, 0
; i end address is: 17 (R17)
L_ADC7328_init17:
; i start address is: 17 (R17)
	CPI        R17, 4
	BRLO       L__ADC7328_init53
	JMP        L_ADC7328_init18
L__ADC7328_init53:
	PUSH       R17
	CLR        R3
	MOV        R2, R17
	CALL       _setRangeRegister+0
	POP        R17
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
; i end address is: 17 (R17)
	JMP        L_ADC7328_init17
L_ADC7328_init18:
;ATmega644P_AD7323.c,91 :: 		setControlRegister(0, SETUP_1);                     // Control register
	LDI        R27, 48
	MOV        R3, R27
	LDI        R27, 128
	MOV        R4, R27
	CLR        R2
	CALL       _setControlRegister+0
;ATmega644P_AD7323.c,92 :: 		write2bytes(0xFE00);                                // Sequence register (no kidding)
	LDI        R27, 0
	MOV        R2, R27
	LDI        R27, 254
	MOV        R3, R27
	CALL       _write2bytes+0
;ATmega644P_AD7323.c,95 :: 		}//ADC7328_init
;ATmega644P_AD7323.c,94 :: 		return;
;ATmega644P_AD7323.c,95 :: 		}//ADC7328_init
L_end_ADC7328_init:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _ADC7328_init

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 16
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ATmega644P_AD7323.c,97 :: 		void main() {
;ATmega644P_AD7323.c,98 :: 		uint16_t buffer[8], result = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
;ATmega644P_AD7323.c,101 :: 		SPI_init();
	CALL       _SPI_init+0
;ATmega644P_AD7323.c,102 :: 		ADC7328_init();
	CALL       _ADC7328_init+0
;ATmega644P_AD7323.c,103 :: 		Lcd_Out(2, 1, txt1);
	LDI        R27, #lo_addr(_txt1+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt1+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ATmega644P_AD7323.c,105 :: 		while (1) {
L_main20:
;ATmega644P_AD7323.c,106 :: 		result = write2bytes(0x0000) & 0x1FFF; // solely get least 13 bits
	CLR        R2
	CLR        R3
	CALL       _write2bytes+0
	ANDI       R16, 255
	ANDI       R17, 31
; result start address is: 20 (R20)
	MOVW       R20, R16
;ATmega644P_AD7323.c,107 :: 		if ((result & 0x1000) >> 12) {// bit12 = 1
	ANDI       R16, 0
	ANDI       R17, 16
	LDI        R27, 12
L__main55:
	LSR        R17
	ROR        R16
	DEC        R27
	BRNE       L__main55
L__main56:
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__main57
	JMP        L_main22
L__main57:
;ATmega644P_AD7323.c,108 :: 		sprintf(buffer, "%4u", result & 0x0FFF);
	MOVW       R18, R20
	ANDI       R18, 255
	ANDI       R19, 15
; result end address is: 20 (R20)
	MOVW       R16, R28
	PUSH       R19
	PUSH       R18
	LDI        R27, hi_addr(?lstr_1_ATmega644P_AD7323+0)
	PUSH       R27
	LDI        R27, #lo_addr(?lstr_1_ATmega644P_AD7323+0)
	PUSH       R27
	PUSH       R17
	PUSH       R16
	CALL       _sprintf+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 6
	OUT        SPL+0, R26
	OUT        SPL+1, R27
;ATmega644P_AD7323.c,109 :: 		Lcd_Out(1, 1, "+");
	LDI        R27, #lo_addr(?lstr2_ATmega644P_AD7323+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr2_ATmega644P_AD7323+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ATmega644P_AD7323.c,110 :: 		Lcd_Out(1, 2, buffer);
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ATmega644P_AD7323.c,111 :: 		}//if
	JMP        L_main23
L_main22:
;ATmega644P_AD7323.c,113 :: 		sprintf(buffer, "%4u", (~result) & 0x0FFF);
; result start address is: 20 (R20)
	MOVW       R16, R20
	COM        R16
	COM        R17
; result end address is: 20 (R20)
	MOVW       R18, R16
	ANDI       R18, 255
	ANDI       R19, 15
	MOVW       R16, R28
	PUSH       R19
	PUSH       R18
	LDI        R27, hi_addr(?lstr_3_ATmega644P_AD7323+0)
	PUSH       R27
	LDI        R27, #lo_addr(?lstr_3_ATmega644P_AD7323+0)
	PUSH       R27
	PUSH       R17
	PUSH       R16
	CALL       _sprintf+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 6
	OUT        SPL+0, R26
	OUT        SPL+1, R27
;ATmega644P_AD7323.c,114 :: 		Lcd_Out(1, 1, "-");
	LDI        R27, #lo_addr(?lstr4_ATmega644P_AD7323+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr4_ATmega644P_AD7323+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ATmega644P_AD7323.c,115 :: 		Lcd_Out(1, 2, buffer);
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ATmega644P_AD7323.c,116 :: 		}//else
L_main23:
;ATmega644P_AD7323.c,118 :: 		}//while
	JMP        L_main20
;ATmega644P_AD7323.c,121 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
