#line 1 "C:/Users/Konstantin/Desktop/ATmega644P_AD7323/source/ATmega644P_AD7323.c"
#line 1 "c:/users/konstantin/desktop/atmega644p_ad7323/source/defs.h"
#line 21 "c:/users/konstantin/desktop/atmega644p_ad7323/source/defs.h"
sbit LCD_RS at PORTD2_bit;
sbit LCD_EN at PORTD3_bit;
sbit LCD_D4 at PORTD4_bit;
sbit LCD_D5 at PORTD5_bit;
sbit LCD_D6 at PORTD6_bit;
sbit LCD_D7 at PORTD7_bit;
sbit LCD_RS_Direction at DDD2_bit;
sbit LCD_EN_Direction at DDD3_bit;
sbit LCD_D4_Direction at DDD4_bit;
sbit LCD_D5_Direction at DDD5_bit;
sbit LCD_D6_Direction at DDD6_bit;
sbit LCD_D7_Direction at DDD7_bit;



sbit Chip_Select at PORTB4_bit;
sbit Chip_Select_Direction at DDB4_bit;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
#line 3 "C:/Users/Konstantin/Desktop/ATmega644P_AD7323/source/ATmega644P_AD7323.c"
char txt1[] = "AD7328-Data";

uint16_t write2bytes(uint16_t command) {
uint8_t higherByte, lowerByte;
uint16_t result;

 higherByte = (uint8_t)((command & 0xFF00) >> 8);
 lowerByte = (uint8_t)(command & 0x00FF);

 Chip_Select = 0;

 SPDR = higherByte;
 while(!(SPSR & (1<<SPIF)));
 result = SPDR & 0xFF;
 result <<= 8;
 SPDR = lowerByte;
 while(!(SPSR & (1<<SPIF)));
 result |= SPDR;

 Chip_Select = 1;

 return result;
}

void setRangeRegister(uint8_t ch, uint8_t range) {
static uint16_t range_ = 0xA000;

 if ((ch < 0) || (ch > 3)) return;

 switch (ch) {
 case 0:
 range_ &=  0xE7FF ;
 range_ |= range << 11;
 break;
 case 1:
 range_ &=  0xF9FF ;
 range_ |= range << 9;
 break;
 case 2:
 range_ &=  0xFE7F ;
 range_ |= range << 7;
 break;
 case 3:
 range_ &=  0xFF9F ;
 range_ |= range << 5;
 break;
 default: break;
 }

 Chip_Select = 0;
 write2bytes(range_);
 Chip_Select = 1;

 return;
}


void SPI_init(void) {

 DDB6_bit = 0;
 DDB5_bit = 1;
 Chip_Select = 1;
 Chip_Select_Direction = 1;
 SPI1_Init();

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 return;
}

void setControlRegister(uint8_t ch, uint16_t setup) {

 if ((ch < 0) || (ch > 7)) return;

 setup |= ((ch & 0x07) << 10);
 Chip_Select = 0;
 write2bytes(setup);
 Chip_Select = 1;

 return;
}

void ADC7328_init(void) {
uint8_t i = 0;

 for (i = 0; i < 4; i++) setRangeRegister(i,  0x00 );
 setControlRegister(0,  0x8030 );
 write2bytes(0xFE00);

 return;
}

void main() {
uint16_t buffer[8], result = 0;


 SPI_init();
 ADC7328_init();
 Lcd_Out(2, 1, txt1);

 while (1) {
 result = write2bytes(0x0000) & 0x1FFF;
 if ((result & 0x1000) >> 12) {
 sprintf(buffer, "%4u", result & 0x0FFF);
 Lcd_Out(1, 1, "+");
 Lcd_Out(1, 2, buffer);
 }
 else {
 sprintf(buffer, "%4u", (~result) & 0x0FFF);
 Lcd_Out(1, 1, "-");
 Lcd_Out(1, 2, buffer);
 }

 }

 return;
}
