#ifndef defs_h
#define defs_h

// range constants
#define BIP10  0x00 // +/-10V
#define BIP5   0x01 // +/-5V
#define BIP2V5 0x02 // +/-2.5
#define UNI10  0x03 // +10V

#define CH0_MASK 0xE7FF // 0b1110011111111111
#define CH1_MASK 0xF9FF // 0b1111100111111111
#define CH2_MASK 0xFE7F // 0b1111111001111111
#define CH3_MASK 0xFF9F // 0b1111111110011111

// sequence is not used, straight binary output coding, normal power mode, single ended channel
#define SETUP_1 0x8030//0b1000000000110000;
// sequence is used, straight binary output coding, normal power mode, single ended channel
#define SETUP_2 0x8034//0b1000000000110100

// LCD module connections
sbit LCD_RS at PORTD2_bit;
sbit LCD_EN at PORTD3_bit;
sbit LCD_D4 at PORTD4_bit;
sbit LCD_D5 at PORTD5_bit;
sbit LCD_D6 at PORTD6_bit;
sbit LCD_D7 at PORTD7_bit;
sbit LCD_RS_Direction at DDD2_bit;
sbit LCD_EN_Direction at DDD3_bit;
sbit LCD_D4_Direction at DDD4_bit;
sbit LCD_D5_Direction at DDD5_bit;
sbit LCD_D6_Direction at DDD6_bit;
sbit LCD_D7_Direction at DDD7_bit;
// End LCD module connections

// Chip select module connections
sbit Chip_Select at PORTB4_bit;
sbit Chip_Select_Direction at DDB4_bit;
// End chip select module connections

typedef unsigned char uint8_t;
typedef unsigned int uint16_t;

#endif